import { MouseEvent } from 'react';
export interface CloneProps {
    /** Whether or not to display a pulse animation around the spotlighted element */
    pulse: boolean;
    style: Record<string, any>;
    /** The name of the SpotlightTarget */
    target?: string;
    /** The spotlight target node */
    targetNode: HTMLElement;
    /** The background color of the element being highlighted */
    targetBgColor?: string;
    /** Function to fire when a user clicks on the cloned target */
    targetOnClick?: (eventData: {
        event: MouseEvent<HTMLElement>;
        target?: string;
    }) => void;
    /** The border-radius of the element being highlighted */
    targetRadius?: number;
    /**
     * A `testId` prop is provided for specified elements,
     * which is a unique string that appears as a data attribute `data-testid` in the rendered code,
     * serving as a hook for automated tests.
     */
    testId?: string;
}
declare const Clone: (props: CloneProps) => JSX.Element;
export default Clone;
