import React, { Component, ElementType, ReactNode } from 'react';
import { HeaderComponentProps, FooterComponentProps } from '@kalamazoo/modal-dialog';
import { Actions } from '../types';
declare type Props = {
    /** Buttons to render in the footer */
    actions?: Actions;
    /** The elements rendered in the modal */
    children: ReactNode;
    /** Path to the the your image */
    image?: string;
    /** Optional element rendered above the body */
    header?: ElementType<HeaderComponentProps>;
    /** Optional element rendered below the body */
    footer?: ElementType<FooterComponentProps>;
    /** Heading text rendered above the body */
    heading?: string;
};
export default class OnboardingModal extends Component<Props> {
    headerComponent: (props: Props) => React.ComponentClass<HeaderComponentProps, any> | React.FunctionComponent<HeaderComponentProps> | (() => JSX.Element);
    footerComponent: (props: Props) => React.ComponentClass<FooterComponentProps, any> | React.FunctionComponent<FooterComponentProps> | (() => JSX.Element | null);
    render(): JSX.Element;
}
export {};
