import React from 'react';
import { Props as SpotlightProps } from './Spotlight';
import { ElementBoundingBox } from '../utils/use-element-box';
export interface Props extends SpotlightProps {
    /** the spotlight tagert dom element */
    targetNode: HTMLElement;
    /** Called when the component has been mounted */
    onOpened: () => any;
    /** Called when the component has been unmounted */
    onClosed: () => any;
    testId: string;
}
interface State {
    replacementElement: HTMLElement | null;
}
declare class SpotlightInner extends React.Component<Props, State> {
    static defaultProps: {
        dialogWidth: number;
        pulse: boolean;
    };
    state: {
        replacementElement: null;
    };
    componentDidUpdate(prevProps: Props): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    isPositionFixed: (element: Element) => boolean;
    hasPositionFixedParent: (element: HTMLElement, _maxTries?: number) => boolean;
    getTargetNodeStyle: (box: ElementBoundingBox) => {};
    render(): JSX.Element;
}
export default SpotlightInner;
